; ModuleID = 'Faust LLVM backend'
target datalayout = "e-p:64:64:64-i1:8:8-i8:8:8-i16:16:16-i32:32:32-i64:64:64-f32:32:32-f64:64:64-v64:64:64-v128:128:128-a0:0:64-s0:64:64-f80:128:128-n8:16:32:64"
target triple = "x86_64-unknown-linux-gnu"

%struct.Meta = type <{ i8 }>
%struct.UIGlue = type { i8*, void (i8*, i8*)*, void (i8*, i8*)*, void (i8*, i8*)*, void (i8*, i8*)*, void (i8*)*, void (i8*, i8*, double*)*, void (i8*, i8*, double*)*, void (i8*, i8*, double*)*, void (i8*, i8*, double*, double, double, double, double)*, void (i8*, i8*, double*, double, double, double, double)*, void (i8*, i8*, double*, double, double, double, double)*, void (i8*, i8*, double*, i32)*, void (i8*, i8*, double*, i8**, double, double)*, void (i8*, i8*, double*, double, double)*, void (i8*, i8*, double*, double, double)*, void (i8*, double*, i8*, i8*)* }
%struct.dsp_llvm = type { double }

@fSamplingFreq = private global i32 0
@example = private constant [8 x i8] c"example\00"
@gain = private constant [5 x i8] c"gain\00"

declare void @free(i8*) align 2

define void @destroy_llvm(%struct.dsp_llvm* %dsp) align 2 {
entry:
  br label %return

return:                                           ; preds = %entry
  ret void
}

define void @delete_llvm(%struct.dsp_llvm* %dsp) {
entry:
  %0 = bitcast %struct.dsp_llvm* %dsp to i8*
  tail call void @destroy_llvm(%struct.dsp_llvm* %dsp)
  tail call void @free(i8* %0)
  ret void
}

declare i8* @malloc(i64)

define %struct.dsp_llvm* @new_llvm() {
entry:
  %ptr_size = getelementptr %struct.dsp_llvm* null, i64 1
  %size = ptrtoint %struct.dsp_llvm* %ptr_size to i64
  %0 = tail call i8* @malloc(i64 %size)
  %1 = bitcast i8* %0 to %struct.dsp_llvm*
  ret %struct.dsp_llvm* %1
}

define void @buildUserInterface_llvm(%struct.dsp_llvm* %dsp, %struct.UIGlue* %interface) align 2 {
init:
  %0 = getelementptr %struct.UIGlue* %interface, i64 0, i32 0
  %1 = load i8** %0
  br label %block_code

block_code:                                       ; preds = %init
  %2 = getelementptr %struct.UIGlue* %interface, i64 0, i32 4
  %3 = load void (i8*, i8*)** %2
  tail call void %3(i8* %1, i8* getelementptr inbounds ([8 x i8]* @example, i32 0, i32 0))
  %4 = getelementptr %struct.UIGlue* %interface, i64 0, i32 11
  %5 = load void (i8*, i8*, double*, double, double, double, double)** %4
  %6 = getelementptr inbounds %struct.dsp_llvm* %dsp, i32 0, i32 0
  tail call void %5(i8* %1, i8* getelementptr inbounds ([5 x i8]* @gain, i32 0, i32 0), double* %6, double 3.000000e-01, double 0.000000e+00, double 1.000000e+01, double 1.000000e-02)
  %7 = getelementptr %struct.UIGlue* %interface, i64 0, i32 5
  %8 = load void (i8*)** %7
  tail call void %8(i8* %1)
  br label %return

return:                                           ; preds = %block_code
  ret void
}

define i32 @getNumInputs_llvm(%struct.dsp_llvm*) {
entry:
  ret i32 2
}

define i32 @getNumOutputs_llvm(%struct.dsp_llvm*) {
entry:
  ret i32 1
}

define void @classInit_llvm(i32 %samplingFreq) align 2 {
entry:
  br label %return

return:                                           ; preds = %entry
  ret void
}

define void @instanceInit_llvm(%struct.dsp_llvm* %dsp, i32 %samplingFreq) align 2 {
entry:
  br label %block_code

block_code:                                       ; preds = %entry
  store i32 %samplingFreq, i32* @fSamplingFreq
  %0 = getelementptr inbounds %struct.dsp_llvm* %dsp, i32 0, i32 0
  store double 3.000000e-01, double* %0
  br label %return

return:                                           ; preds = %block_code
  ret void
}

define void @compute_llvm(%struct.dsp_llvm* %dsp, i32 %count, double** noalias %inputs, double** noalias %outputs) align 2 {
block_code:
  br label %block_code1

block_code1:                                      ; preds = %block_code
  %input0 = alloca double*
  %0 = getelementptr double** %inputs, i32 0
  %1 = load double** %0
  store double* %1, double** %input0
  %input1 = alloca double*
  %2 = getelementptr double** %inputs, i32 1
  %3 = load double** %2
  store double* %3, double** %input1
  %output0 = alloca double*
  %4 = getelementptr double** %outputs, i32 0
  %5 = load double** %4
  store double* %5, double** %output0
  %fSlow0 = alloca double
  %6 = getelementptr inbounds %struct.dsp_llvm* %dsp, i32 0, i32 0
  %7 = load double* %6
  store double %7, double* %fSlow0
  br label %init_block

init_block:                                       ; preds = %block_code1
  %i = alloca i32
  store i32 0, i32* %i
  %8 = load i32* %i
  br label %exec_code

exec_code:                                        ; preds = %block_code3, %init_block
  %i2 = phi i32 [ %8, %init_block ], [ %nextindex, %block_code3 ]
  br label %block_code3

block_code3:                                      ; preds = %exec_code
  %9 = load i32* %i
  %10 = load double** %output0
  %11 = getelementptr double* %10, i32 %9
  %12 = load double* %fSlow0
  %13 = load i32* %i
  %14 = load double** %input0
  %15 = getelementptr double* %14, i32 %13
  %16 = load double* %15
  %17 = load i32* %i
  %18 = load double** %input1
  %19 = getelementptr double* %18, i32 %17
  %20 = load double* %19
  %21 = fadd double %16, %20
  %22 = fmul double %12, %21
  store double %22, double* %11
  %23 = load i32* %i
  %nextindex = add i32 %23, 1
  store i32 %nextindex, i32* %i
  %24 = load i32* %i
  %25 = icmp ult i32 %24, %count
  %26 = select i1 %25, i32 1, i32 0
  %27 = trunc i32 %26 to i1
  br i1 %27, label %exec_code, label %exit_block

exit_block:                                       ; preds = %block_code3
  br label %return

return:                                           ; preds = %exit_block
  ret void
}

define void @init_llvm(%struct.dsp_llvm* %dsp, i32 %samplingFreq) align 2 {
entry:
  tail call void @classInit_llvm(i32 %samplingFreq)
  tail call void @instanceInit_llvm(%struct.dsp_llvm* %dsp, i32 %samplingFreq)
  ret void
}
